import threading
from loguru import logger
from DataObject import DataObject


POISON_PILL = DataObject(name="PoisonPill", topic="kill", payload=None)


class GenericSinkHandler(threading.Thread):
    def __init__(self, config, inQueue, experiment):
        super().__init__()

        self.config = config
        self.inQueue = inQueue
        self.experiment = experiment

    def run(self):
        logger.debug("GenericSinkHandler loop started")

        while True:
            dataObject = self.inQueue.get()
            if (dataObject == POISON_PILL):
                logger.debug("GenericSinkHandler swallowed the poison pill")
                break
            logger.info(f"GenericSinkHandler received {dataObject} for experiment {self.experiment}")
            

    def stop(self):
        self.inQueue.put(POISON_PILL)
        logger.debug("kill flag set")
